;***********************************************************************************************
; Broba.asm
;    LASER TAG (  MILES ).
; PIC16F84A       4 .
;===============================================================================================
            LIST       p=16F84A    ;   : PIC16F84A.
            __CONFIG   B'11111111110101'  
                                   ;    :  XT-,
                                   ; WDT ,    , PWRT
                                   ;  (1111 0101). 
;=============================================================================================
;     .
;=============================================================================================
OptionR     equ        01h         ;  Option - 1
Status      equ        03h         ;  Status
PortB       equ        06h         ;  B
TrisB       equ        06h         ;  Tris B - 1
PortA       equ        05h         ;  A
TrisA       equ        05h         ;  Tris A - 1
IntCon      equ        0Bh         ;  IntCon
;=============================================================================================
;       .
;=============================================================================================
Sec         equ        0Ch         ;   .
SecH        equ        0Dh         ;   .
SecL        equ        0Eh         ;   .
Byte_F      equ        10h         ;       F1  F2
Byte_AB     equ        11h         ;       A  B
Byte1       equ        12h         ;   
Byte2       equ        13h         ;   
Byte3       equ        14h         ;   
Color       equ        0Fh         ;    
Status_PER  equ        1Fh         ;     (    )
Byte_Tek    equ        20h         ;   
Sec_OSN     equ        21h         ;      
KalibrLVL   equ        22h         ;   
;=============================================================================================
;         
; ,      (   
; ).
;=============================================================================================
F           equ        1           ;    ,   
                                   ;  .
;=============================================================================================
;      STATUS ()    
;     ).
;=============================================================================================
RP0         equ        5           ;  5-   STATUS  RP0.
;=============================================================================================
;     .
;=============================================================================================
            org        0           ;       PC.
            goto       START       ;     START.
;*********************************************************************************************

;-------------------------------      -----------------------------------
;*********************************************************************************************
;  
;---------------------------------------------------------------------------------------------
START  
            clrf       IntCon      ;     IntCon. ( )  .
            clrwdt                 ;    WDT.

            bsf        Status,RP0  ;  5-   Status  . (   1)

            movlw      B'11111111' ;    W  .11111111        
            movwf      TrisB       ;       , .   
            movlw      B'11101100' ;    W  .11101100        
            movwf      TrisA       ;   2  3    ,  0,1,4 -  . 
            movlw      B'00001111' ;    W  .11101100      (.143 = 1000 1111)
            movwf      OptionR     ;    111=128,    WDT, 
                                   ; 000 -      ,    (  !)
            bcf        Status,RP0  ;  5-   Status  . (   0)        
            

               
;--------------------------------------------------------------------------------------------
;    
;--------------------------------------------------------------------------------------------

Opros_All 
            movlw      B'00000000' ;    W  .00000000        
            movwf      Byte1       ;  
            movlw      B'00000000' ;    W  .00000000        
            movwf      Byte2       ;  
            movlw      B'00000000' ;    W  .00000000        
            movwf      Byte3       ;  

            movlw      B'00000000' ;    W  .00000000        
            movwf      Byte_F      ;   F1  F2
Opros_AB    movlw      B'00000000' ;    W  .00000000        
            movwf      Byte_AB     ;   A  B

            btfss      PortA,2     ;   F1 ( RA2)
            bsf        Byte_F,0    ;  1    0 (.. F1 )
            btfss      PortA,3     ;   F2 ( RA3)
            bsf        Byte_F,1    ;  1    0 (.. F2 )

            btfss      PortB,0     ;   A1 ( RB0)
            bsf        Byte_AB,0   ;  1    0 (.. A1 )
            btfss      PortB,1     ;   A2 ( RB1)
            bsf        Byte_AB,1   ;  1    0 (.. A2 )
            btfss      PortB,2     ;   A3 ( RB2)
            bsf        Byte_AB,2   ;  1    0 (.. A3 )
            btfss      PortB,3     ;   A4 ( RB3)
            bsf        Byte_AB,3   ;  1    0 (.. A4 )
            btfss      PortB,4     ;   B1 ( RB4)
            bsf        Byte_AB,4   ;  1    0 (.. B1 )
            btfss      PortB,5     ;   B2 ( RB5)
            bsf        Byte_AB,5   ;  1    0 (.. B2 )
            btfss      PortB,6     ;   B3 ( RB6)
            bsf        Byte_AB,6   ;  1    0 (.. B3 )
            btfss      PortB,7     ;   B4 ( RB7)
            bsf        Byte_AB,7   ;  1    0 (.. B4 )

            movlw      B'00000000' ;    W  .00000001 
            subwf      Byte_AB,0   ;   Byte  W,  =0 --> Z=1 
            btfsc      Status,2    ;  Z
            goto       Pro_F1
            goto       FFFF       

Pro_F1      movlw      B'00000000' ;    W  .00000001 
            subwf      Byte_F,0   ;   Byte_F  W,  =0 --> Z=1 
            btfsc      Status,2    ;  Z
            goto       Opros_All
            goto       FFFF       

FFFF        goto       Formirovka



;--------------------------------------------------------------------------------------------
;    
;--------------------------------------------------------------------------------------------
Formirovka 
            movlw      B'00000011'  ;    W  .00000000
            subwf      Byte_F,0     ;   Byte_F  W,  =0 --> Z=1 
            btfsc      Status,2     ;  Z,    
            goto       Opros_OTG    ;     


            btfsc      Byte_F,0     ;    F1
            goto       Form_F1
            btfsc      Byte_F,1     ;    F2
            goto       Form_F2
 

;   ,     

            movlw      B'00000001' ;    W  .00000001 
            subwf      Byte_AB,0   ;   Byte  W,  =0 --> Z=1 
            btfsc      Status,2    ;  Z
            goto       F_A1        ;  Z=1, ..   0, ..   

            movlw      B'00000010' ;    W  .00000010 
            subwf      Byte_AB,0   ;   Byte  W,  =0 --> Z=1 
            btfsc      Status,2    ;  Z
            goto       F_A2        ;  Z=1, ..   0, ..   

            movlw      B'00000100' ;    W  .00000100
            subwf      Byte_AB,0   ;   Byte  W,  =0 --> Z=1 
            btfsc      Status,2    ;  Z
            goto       F_A3        ;  Z=1, ..   0, ..   

            movlw      B'00001000' ;    W  .00000100
            subwf      Byte_AB,0   ;   Byte  W,  =0 --> Z=1 
            btfsc      Status,2    ;  Z
            goto       F_A4        ;  Z=1, ..   0, ..   

            movlw      B'00010000' ;    W  .00000100
            subwf      Byte_AB,0   ;   Byte  W,  =0 --> Z=1 
            btfsc      Status,2    ;  Z
            goto       F_B1        ;  Z=1, ..   0, ..   

            movlw      B'00100000' ;    W  .00000100
            subwf      Byte_AB,0   ;   Byte  W,  =0 --> Z=1 
            btfsc      Status,2    ;  Z
            goto       F_B2        ;  Z=1, ..   0, ..   

            movlw      B'01000000' ;    W  .00000100
            subwf      Byte_AB,0   ;   Byte  W,  =0 --> Z=1 
            btfsc      Status,2    ;  Z
            goto       F_B3        ;  Z=1, ..   0, ..   

            movlw      B'10000000' ;    W  .00000100
            subwf      Byte_AB,0   ;   Byte  W,  =0 --> Z=1 
            btfsc      Status,2    ;  Z
            goto       F_B4        ;  Z=1, ..   0, ..   

            goto       Opros_OTG   ;       


F_A1        movlw      0x83        ;          
            movwf      Byte1       ; 
            movlw      0x04        ;          
            movwf      Byte2       ; 
            movlw      0xE8        ;  XOR         
            movwf      Byte3       ; 
            goto       Paket       ;    

F_A2        movlw      0x83        ;          
            movwf      Byte1       ; 
            movlw      0x06        ;           
            movwf      Byte2       ; 
            movlw      0xE8        ;  XOR         
            movwf      Byte3       ; 
            goto       Paket       ;    

F_A3        movlw      0x83        ;          
            movwf      Byte1       ; 
            movlw      0x00        ;           
            movwf      Byte2       ; 
            movlw      0xE8        ;  XOR         
            movwf      Byte3       ; 
            goto       Paket       ;    

F_A4        movlw      0x83        ;          
            movwf      Byte1       ; 
            movlw      0x0D        ;           
            movwf      Byte2       ; 
            movlw      0xE8        ;  XOR         
            movwf      Byte3       ; 
            goto       Paket       ;    

F_B1        movlw      0xA0        ;          
            movwf      Byte1       ; 
            movlw      0x0A        ;  -10         
            movwf      Byte2       ; 
            movlw      0xE8        ;  XOR         
            movwf      Byte3       ; 
            goto       Paket       ;    


F_B2        movlw      0xA1        ;          
            movwf      Byte1       ; 
            movlw      0x0A        ;  +10         
            movwf      Byte2       ; 
            movlw      0xE8        ;  XOR         
            movwf      Byte3       ; 
            goto       Paket       ;    

F_B3        movlw      0x83        ;          
            movwf      Byte1       ; 
            movlw      0x09        ;   /        
            movwf      Byte2       ; 
            movlw      0xE8        ;  XOR         
            movwf      Byte3       ; 
            goto       Paket       ;    

F_B4        movlw      0x83        ;          
            movwf      Byte1       ; 
            movlw      0x10        ;  -              
            movwf      Byte2       ; 
            movlw      0xE8        ;  XOR         
            movwf      Byte3       ; 
            goto       Paket       ;    

Form_F1     btfsc      Byte_F,1     ;    F2
            goto       Opros_OTG    ;      .,   ,     

            movlw      B'00000000' ;    W  .00000000
            subwf      Byte_AB,0   ;   Byte  W,  =0 --> Z=1 
            btfsc      Status,2    ;  Z
            goto       Opros_AB    ;        A  B

            movlw      B'00000001' ;    W  .00000001 
            subwf      Byte_AB,0   ;   Byte  W,  =0 --> Z=1 
            btfsc      Status,2    ;  Z
            goto       F_F1_A1        ;  Z=1, ..   0, ..   

            movlw      B'00000010' ;    W  .00000010 
            subwf      Byte_AB,0   ;   Byte  W,  =0 --> Z=1 
            btfsc      Status,2    ;  Z
            goto       F_F1_A2        ;  Z=1, ..   0, ..   

            movlw      B'00000100' ;    W  .00000100
            subwf      Byte_AB,0   ;   Byte  W,  =0 --> Z=1 
            btfsc      Status,2    ;  Z
            goto       F_F1_A3        ;  Z=1, ..   0, ..   

            movlw      B'00001000' ;    W  .00000100
            subwf      Byte_AB,0   ;   Byte  W,  =0 --> Z=1 
            btfsc      Status,2    ;  Z
            goto       F_F1_A4        ;  Z=1, ..   0, ..   

            movlw      B'00010000' ;    W  .00000100
            subwf      Byte_AB,0   ;   Byte  W,  =0 --> Z=1 
            btfsc      Status,2    ;  Z
            goto       F_F1_B1        ;  Z=1, ..   0, ..   

            movlw      B'00100000' ;    W  .00000100
            subwf      Byte_AB,0   ;   Byte  W,  =0 --> Z=1 
            btfsc      Status,2    ;  Z
            goto       F_F1_B2        ;  Z=1, ..   0, ..   

            movlw      B'01000000' ;    W  .00000100
            subwf      Byte_AB,0   ;   Byte  W,  =0 --> Z=1 
            btfsc      Status,2    ;  Z
            goto       F_F1_B3        ;  Z=1, ..   0, ..   

            movlw      B'10000000' ;    W  .00000100
            subwf      Byte_AB,0   ;   Byte  W,  =0 --> Z=1 
            btfsc      Status,2    ;  Z
            goto       F_F1_B4        ;  Z=1, ..   0, ..   

            goto       Opros_OTG

Form_F2     btfsc      Byte_F,0     ;    F1
            goto       Opros_OTG    ;      .,   ,     

            movlw      B'00000000' ;    W  .00000000
            subwf      Byte_AB,0   ;   Byte  W,  =0 --> Z=1 
            btfsc      Status,2    ;  Z
            goto       Opros_AB    ;        A  B

            movlw      B'00000001' ;    W  .00000001 
            subwf      Byte_AB,0   ;   Byte  W,  =0 --> Z=1 
            btfsc      Status,2    ;  Z
            goto       F_F2_A1        ;  Z=1, ..   0, ..   

            movlw      B'00000010' ;    W  .00000010 
            subwf      Byte_AB,0   ;   Byte  W,  =0 --> Z=1 
            btfsc      Status,2    ;  Z
            goto       F_F2_A2        ;  Z=1, ..   0, ..   

            movlw      B'00000100' ;    W  .00000100
            subwf      Byte_AB,0   ;   Byte  W,  =0 --> Z=1 
            btfsc      Status,2    ;  Z
            goto       F_F2_A3        ;  Z=1, ..   0, ..   

            movlw      B'00001000' ;    W  .00000100
            subwf      Byte_AB,0   ;   Byte  W,  =0 --> Z=1 
            btfsc      Status,2    ;  Z
            goto       F_F2_A4        ;  Z=1, ..   0, ..   

            movlw      B'00010000' ;    W  .00000100
            subwf      Byte_AB,0   ;   Byte  W,  =0 --> Z=1 
            btfsc      Status,2    ;  Z
            goto       F_F2_B1        ;  Z=1, ..   0, ..   

            movlw      B'00100000' ;    W  .00000100
            subwf      Byte_AB,0   ;   Byte  W,  =0 --> Z=1 
            btfsc      Status,2    ;  Z
            goto       F_F2_B2        ;  Z=1, ..   0, ..   

            movlw      B'01000000' ;    W  .00000100
            subwf      Byte_AB,0   ;   Byte  W,  =0 --> Z=1 
            btfsc      Status,2    ;  Z
            goto       F_F2_B3        ;  Z=1, ..   0, ..   

            movlw      B'10000000' ;    W  .00000100
            subwf      Byte_AB,0   ;   Byte  W,  =0 --> Z=1 
            btfsc      Status,2    ;  Z
            goto       F_F2_B4        ;  Z=1, ..   0, ..   

            goto       Opros_OTG

F_F1_A1     movlw      0xA9        ;          
            movwf      Byte1       ; 
            movlw      0x00        ;    ( )        
            movwf      Byte2       ; 
            movlw      0xE8        ;  XOR         
            movwf      Byte3       ; 
            goto       Paket       ;    

F_F1_A2     movlw      0xA9        ;          
            movwf      Byte1       ; 
            movlw      0x01        ;    ( )        
            movwf      Byte2       ; 
            movlw      0xE8        ;  XOR         
            movwf      Byte3       ; 
            goto       Paket       ;    

F_F1_A3     movlw      0xA9        ;          
            movwf      Byte1       ; 
            movlw      0x02        ;    ( )        
            movwf      Byte2       ; 
            movlw      0xE8        ;  XOR         
            movwf      Byte3       ; 
            goto       Paket       ;    

F_F1_A4     movlw      0xA9        ;          
            movwf      Byte1       ; 
            movlw      0x03        ;    ( )        
            movwf      Byte2       ; 
            movlw      0xE8        ;  XOR         
            movwf      Byte3       ; 
            goto       Paket       ;    

F_F1_B1     movlw      0x00        ;     :        
            movwf      Color       ; 
            goto       Opros_OTG   ;   

F_F1_B2     movlw      0x40        ;     :        
            movwf      Color       ; 
            goto       Opros_OTG   ;   

F_F1_B3     movlw      0x80        ;     :       
            movwf      Color       ; 
            goto       Opros_OTG   ;   

F_F1_B4     movlw      0xC0        ;     :        
            movwf      Color       ; 
            goto       Opros_OTG   ;   

F_F2_A1     movlw      .65         ;    128 ( 65)        
            movwf      Byte1       ; 
            movf       Color,0     ;      
            addlw      B'00000000' ;   1 (00dddd00) = 00000000,   2    
            movwf      Byte2       ; 
            movf       Byte1,0     ;   
            addwf      Byte2,0     ;           
            movwf      Byte3       ; 
            goto       Paket       ;    

F_F2_A2     movlw      .65         ;    128 ( 65)        
            movwf      Byte1       ; 
            movf       Color,0     ;      
            addlw      B'00010100' ;   10 (00dddd00) = 00010100,   2    
            movwf      Byte2       ; 
            movf       Byte1,0     ;   
            addwf      Byte2,0     ;           
            movwf      Byte3       ; 
            goto       Paket       ;    

F_F2_A3     movlw      .65         ;    128 ( 65)        
            movwf      Byte1       ; 
            movf       Color,0     ;      
            addlw      B'00011000' ;   15 (00dddd00) = 00011000,   2    
            movwf      Byte2       ; 
            movf       Byte1,0     ;   
            addwf      Byte2,0     ;           
            movwf      Byte3       ; 
            goto       Paket       ;    

F_F2_A4     movlw      .65         ;    128 ( 65)        
            movwf      Byte1       ; 
            movf       Color,0     ;      
            addlw      B'00100100' ;   25 (00dddd00) = 00100100,   2    
            movwf      Byte2       ; 
            movf       Byte1,0     ;   
            addwf      Byte2,0     ;           
            movwf      Byte3       ; 
            goto       Paket       ;    

F_F2_B1     movlw      .65         ;    128 ( 65)        
            movwf      Byte1       ; 
            movf       Color,0     ;      
            addlw      B'00101100' ;   35 (00dddd00) = 00101100,   2    
            movwf      Byte2       ; 
            movf       Byte1,0     ;   
            addwf      Byte2,0     ;           
            movwf      Byte3       ; 
            goto       Paket       ;    

F_F2_B2     movlw      .65         ;    128 ( 65)        
            movwf      Byte1       ; 
            movf       Color,0     ;      
            addlw      B'00110000' ;   40 (00dddd00) = 00110000,   2    
            movwf      Byte2       ; 
            movf       Byte1,0     ;   
            addwf      Byte2,0     ;           
            movwf      Byte3       ; 
            goto       Paket       ;    

F_F2_B3     movlw      .65         ;    128 ( 65)        
            movwf      Byte1       ; 
            movf       Color,0     ;      
            addlw      B'00110100' ;   50 (00dddd00) = 00110100,   2    
            movwf      Byte2       ; 
            movf       Byte1,0     ;   
            addwf      Byte2,0     ;           
            movwf      Byte3       ; 
            goto       Paket       ;    

F_F2_B4     movlw      .65         ;    128 ( 65)        
            movwf      Byte1       ; 
            movf       Color,0     ;      
            addlw      B'00111100' ;   100 (00dddd00) = 00111100,   2    
            movwf      Byte2       ; 
            movf       Byte1,0     ;   
            addwf      Byte2,0     ;           
            movwf      Byte3       ; 
            goto       Paket       ;    

            goto       Opros_OTG


;--------------------------------------------------------------------------------------------
;    =Header+8*(1+2+)=25  (+)
;--------------------------------------------------------------------------------------------
Paket       
;   .  600 .
;       
;   Header      
;         

            movlw      B'10011001'  ;    W  .10011001
                                    ;  7   Header
                                    ;  =25  Header (8*3+1=25)

            movwf      Status_PER   ;    
            
            goto       Null_LEVEL
            

Null_LEVEL
            bcf        PortA,0      ;    0  
            clrwdt                  ;    WDT.

            movlw      .1           ;    W  1
            movwf      KalibrLVL    ;   

            btfsc      Status_PER,7 ;  7  -   Header
            goto       Podgot_Header
           
            decfsz     Status_PER,F ;   
                                    ;   ,     24
            goto       Vibor_BIT    ;    0,    
            goto       LED_Control  ;   ,      

Vibor_BIT   movlw      .33          ;    W  50
                                    ;   ,     0
            movwf      Sec_OSN      ;    o    
 
            rlf        Byte3        ;  -  Byte3-Byate2-Byte1
            rlf        Byte2        ;
            rlf        Byte1        ;         
            btfsc      Status,0     ;   
            goto       Bit_rav_1    ;  =1
            goto       K_Bit_0      ;  =0

Bit_rav_1   movlw      .66          ;    W  100
                                    ;   ,     1
            movwf      Sec_OSN
            incf       KalibrLVL    ;  ,   = 2
            incf       KalibrLVL    ;  ,   = 3
            goto       K_Bit_1

Podgot_Header
            movlw     .133          ;     Headera
            movwf     Sec_OSN       ;      
            bcf       Status_PER,7  ;    Header  0,     
            goto      K_Header

;----------------------------------------
;--------------  --------------
K_Header    nop
            nop
            nop
            nop
            nop
            nop
K_Bit_0     nop
            nop
            nop
            nop
            nop
K_Bit_1     nop
            nop
            nop
            nop


Zaderzhka  
            movlw     .114          ;   
            movwf     Sec
Cicl_Zad
            clrwdt                  ;    WDT.
            nop
            decfsz    Sec,1         ;  
            goto      Cicl_Zad      ;     0
            goto      One_LEVEL     ;   =0, ..   
            

;--------------------------------------------------------------------------------------------
;  
;--------------------------------------------------------------------------------------------
One_LEVEL
            bsf        PortA,0       ;    0  
            clrwdt
            nop
            nop
            nop
            nop
            nop              
            nop
            nop                     ;   1     56 = 9 ..
 
            bcf        PortA,0      ;    0  
            nop                     ;   0     56 = 9 ..
            nop
            nop
            nop
            nop
            decfsz     Sec_OSN,1     ;          
            goto       One_LEVEL                      

            bsf        PortA,0
CicKAL_LVL  decfsz     KalibrLVL,1   ;         
            goto       CicKAL_LVL
            nop
            nop
            goto       Null_LEVEL


;   

LED_Control
            bsf        PortA,1
            movlw      .100          ;    W  5       
            movwf      SecH        ;  
Cicl_LEDH
            movlw      .255        ;    W  255       
            movwf      SecL        ;  
Cicl_LEDL   
            clrwdt          
            nop
            nop
            nop
            decfsz    SecL,1       ;  
            goto      Cicl_LEDL    ;     0
   
            decfsz    SecH,1       ;  
            goto      Cicl_LEDH    ;     0
         
            bcf        PortA,1



;--------------------------------------------------------------------------------------------
;     (            )
;--------------------------------------------------------------------------------------------
Opros_OTG   clrwdt                 ;   WDT.
            bcf        PortA,0     ;     0
            bcf        PortA,1 

            btfss      PortA,2     ;   F1 ( RA2)
            goto       Opros_OTG
            btfss      PortA,3     ;   F2 ( RA3)
            goto       Opros_OTG
            btfss      PortB,0     ;   A1 ( RB0)
            goto       Opros_OTG
            btfss      PortB,1     ;   A2 ( RB1)
            goto       Opros_OTG
            btfss      PortB,2     ;   A3 ( RB2)
            goto       Opros_OTG
            btfss      PortB,3     ;   A4 ( RB3)
            goto       Opros_OTG
            btfss      PortB,4     ;   B1 ( RB4)
            goto       Opros_OTG
            btfss      PortB,5     ;   B2 ( RB5)
            goto       Opros_OTG
            btfss      PortB,6     ;   B3 ( RB6)
            goto       Opros_OTG
            btfss      PortB,7     ;   B4 ( RB7)
            goto       Opros_OTG


         
            goto       Opros_All   ;   ,    START. 

       
;============================================================================================
            end                    ;    .






   


